# Remote Config

Remote Config is a feature that allows you to replace values or properties managed in your application with parameter values defined in the Hackle Dashboard, enabling real-time control of application behavior and configuration.

Navigate to the Remote Config screen in the Hackle Dashboard to configure parameter information and set values based on user identification rules.

## remoteConfig

Calling the `RemoteConfig()` method returns a `hackle.RemoteConfig` instance that holds the Remote Config information for the user (configured parameters and rule information).\
`RemoteConfig()` receives User Identifier information to match user properties against Remote Config rule information.\
You can access the desired parameter and receive its value through the methods provided by `hackle.RemoteConfig`.

```go
import "github.com/hackle-io/hackle-go-sdk/hackle"


//사용자 객체 - 사용자 식별자와 속성 가이드 참조
user := hackle.NewUserBuilder().ID("ae2182e0").Build()

// 원격 구성 정보 담은 인스턴스를 반환합니다.
remoteConfig := hackleClient.RemoteConfig(user)
```

## Remote Config Parameter Lookup

* Since parameter values configured on the Hackle Remote Config screen exist as key-value pairs, you can use the methods below according to the configured parameter type to receive the configured parameter value.

{% hint style="warning" %}
Remove Remote Config-related code after archiving.

Once a Remote Config parameter is archived, you can no longer access the parameter information. Therefore, after archiving a Remote Config parameter, be sure to clean up any related code.
{% endhint %}

### GetString

* Returns parameter values configured as STRING or JSON type.
* Returns the default value or the value configured in the rule, depending on the state decision.

```go
import "github.com/hackle-io/hackle-go-sdk/hackle"

//사용자 객체 - 사용자 식별자와 속성 가이드 참조
user := hackle.NewUserBuilder().ID("ae2182e0").Build()

// 원격 구성 정보 담은 인스턴스를 반환합니다.
remoteConfig := hackleClient.RemoteConfig(user)

stringValue := remoteConfig.GetString("string_key", "default_value")

//JSON Type
jsonValue := remoteConfig.GetString("json_key", "{}")
```

### GetNumber

* Returns the parameter value configured as Number type as a float64 type.
* Returns the default value or the value configured in the rule, depending on the state decision.

```go
import "github.com/hackle-io/hackle-go-sdk/hackle"

//사용자 객체 - 사용자 식별자와 속성 가이드 참조
user := hackle.NewUserBuilder().ID("ae2182e0").Build()

// 원격 구성 정보 담은 인스턴스를 반환합니다.
remoteConfig := hackleClient.RemoteConfig(user)

numberValue := remoteConfig.GetNumber("number_key", 42.0)
```

### GetBool

* Returns parameter values configured as Boolean type.
* Returns the default value or the value configured in the rule, depending on the state decision.

```go
import "github.com/hackle-io/hackle-go-sdk/hackle"

//사용자 객체 - 사용자 식별자와 속성 가이드 참조
user := hackle.NewUserBuilder().ID("ae2182e0").Build()

// 원격 구성 정보 담은 인스턴스를 반환합니다.
remoteConfig := hackleClient.RemoteConfig(user)

boolValue := hackleClient.GetBool("bool_key", false)
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hackle.io/en/development-guide/go/go-remote-config.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
